local frame = CreateFrame("Frame", "TheHurting", UIParent)

frame:SetAllPoints(UIParent)
frame:SetFrameLevel(2001)

local tex = frame:CreateTexture(nil, "OVERLAY")
tex:SetTexture(1, 0, 0, 0)
tex:SetAllPoints(frame)

local fs = frame:CreateFontString(nil, "OVERLAY")
local font = GameFontNormalHuge:GetFont()
fs:SetFont(font, 40)
fs:SetShadowColor(0,0,0)
fs:SetShadowOffset(0.8, -0.8)
fs:SetTextColor(1,1,1, 0)
fs:SetJustifyH("CENTER")
fs:SetJustifyV("MIDDLE")
fs:SetAllPoints(frame)
fs:SetText("Make the hurting stop!")

local function OnEvent(this, event, unit)
	if not unit then unit = "player" end
	if unit ~= "player" then return end
	
	local min, max = UnitHealth(unit) or 0, UnitHealthMax(unit) or 0
	
	local alpha = 0
	if min == 0 or max == 0 then
		-- dead ducky
		alpha = 0
	else
		alpha  = ((max - min)/max)
	end
	tex:SetTexture(1, 0, 0, alpha)
	fs:SetTextColor(1,1,1,alpha)
end

frame:SetScript("OnEvent", OnEvent)
frame:RegisterEvent("UNIT_HEALTH")
frame:RegisterEvent("PLAYER_LOGIN")
